# 2020.08.09

run serve example: `go run ./rux`

## Details

> Run 3 times, take the highest result

### row mux

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 47683/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     48006.28    4248.97   63762.54
  Latency        2.60ms   561.50us    55.95ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.56MB/s
```

### chi

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 47678/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     48099.05    3719.52   57581.12
  Latency        2.60ms   391.22us    23.66ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.58MB/s
```

### echo

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 48108/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     48293.99    4210.82   60022.68
  Latency        2.59ms   513.13us    44.42ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.61MB/s
```

### fasthttp

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 63485/s 15s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     63947.16    5909.93  194814.68
  Latency        1.96ms   299.93us    28.37ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:    12.46MB/s
```

### gin

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 48092/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     48138.31    3708.06   62223.02
  Latency        2.60ms   384.51us    34.89ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.58MB/s
```

- dynamic path

```text
Bombarding http://localhost:3000/user/42 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 47663/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     47953.70    4411.13   57913.18
  Latency        2.60ms   758.22us    51.26ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.55MB/s
```

### gorilla-mux

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 43948/s 22s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     44267.72    4548.34   56762.30
  Latency        2.82ms     0.88ms    44.25ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     7.89MB/s
```

### httprouter

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 47641/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     47861.40    4400.46   57981.36
  Latency        2.61ms   389.75us    57.91ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.53MB/s
```

### rux

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 47629/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     47707.23    5427.95   56901.65
  Latency        2.62ms   546.55us    32.56ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.51MB/s
```

- dynamic path

```text
Bombarding http://localhost:3000/user/42 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 46762/s 21s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     47120.35    4389.49   58621.99
  Latency        2.65ms   760.14us    44.84ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.40MB/s
```

### muxie

- static path

```text
Bombarding http://localhost:3000 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 48587/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     48983.27    3349.44   57914.37
  Latency        2.55ms   529.26us    29.59ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.73MB/s
```

- dynamic path

```text
Bombarding http://localhost:3000/user/42 with 1000000 request(s) using 125 connection(s)
 1000000 / 1000000 [=======================================================================] 100.00% 48131/s 20s
Done!
Statistics        Avg      Stdev        Max
  Reqs/sec     48300.45    3847.76   58396.64
  Latency        2.59ms   554.48us    35.61ms
  HTTP codes:
    1xx - 0, 2xx - 1000000, 3xx - 0, 4xx - 0, 5xx - 0
    others - 0
  Throughput:     8.61MB/s
```
